# Copyright (c) 2023 Arm Limited or its affiliates. All rights reserved.
#
# SPDX-License-Identifier: MIT
---
# FVP is not available for arm based hosts yet
Fetch-FVP-Version-Info:
  extends: .kas_build_cassini
  stage: Setup
  tags:
    - x86_64
  # Store the build artifacts from the job. The download urls of these
  # artifacts are later used by lava jobs to download and test the image.
  variables:
    KAS_CONFIGS: "cassini/tests/corstone1000-fvp"
    FVP_CORSTONE1000_EULA_ACCEPT: "True"
  script:
    # Run build
    - echo "Building target $KAS_CONFIGS"
    - KASFILES=$(./.gitlab/scripts/jobs-to-kas ${KAS_CONFIGS})
    - echo KASFILES = $KASFILES
    - export BB_NUMBER_THREADS="${KUBERNETES_CPU_REQUEST}"
    - export PARALLEL_MAKE="-j ${KUBERNETES_CPU_REQUEST}"
    - kas shell
      --update
      --force-checkout $KASFILES
      -c 'bitbake -e fvp-corstone1000-native' > fvp_data.txt
    - grep '^MODEL' fvp_data.txt | tr -d '"' > fvp_data.env
    - grep '^PV' fvp_data.txt | tr -d '"' >> fvp_data.env
    - grep '^SRC_URI' fvp_data.txt | tr -d '"' | cut -d ';' -f 1 >> fvp_data.env
  artifacts:
    paths:
      - fvp_data.env
    reports:
      dotenv: fvp_data.env
    expire_in: "1 days"

Build-FVP-Docker-Image:
  extends: .build-docker-image
  stage: Build
  variables:
    DOCKER_IMAGE_NAME: cs1k-fvp-test-image
    BUILD_CONTEXT: $CI_PROJECT_DIR/.gitlab/Dockerfiles/$DOCKER_IMAGE_NAME
    BUILDAH_ARGS: --build-arg ARMLMD_LICENSE_FILE=${ARMLMD_LICENSE_FILE}
  needs:
    - Fetch-FVP-Version-Info
  script:
    - BUILDAH_ARGS="${BUILDAH_ARGS} --build-arg MODEL=${MODEL}"
    - BUILDAH_ARGS="${BUILDAH_ARGS} --build-arg MODEL_CODE=${MODEL_CODE}"
    - BUILDAH_ARGS="${BUILDAH_ARGS} --build-arg MODEL_VERSION=${PV}"
    - BUILDAH_ARGS="${BUILDAH_ARGS} --build-arg SRC_URI=${SRC_URI}"
    - !reference [".build-docker-image", script]
